#include <SoftwareSerial.h>
#define rxPin 3 
#define txPin 2 
SoftwareSerial esp01(txPin, rxPin); // SoftwareSerial NAME(TX, RX);

const String ssid_AP = "ESP01";    // your network SSID (name)
const String pass_AP = "12345678"; //"1234test";         // your network password

char ssid[21] = "skynet";    // "SK_WiFiGIGA40F7" your network SSID (name)
char pass[21] = "skynet00";  // "1712037218" your network password 

String ip = "";
String ap = "";

void ipCheck(String response) {
  int st, ed;
  if (response.indexOf(F("PIP")) != -1) {
    st = response.indexOf(F("PIP"))+5;
    ed = response.indexOf('"', st+1);
    ap = response.substring(st, ed);
    response.remove(0, ed+1);
    Serial.print(F("ap: ")); Serial.println(ap);
  }
  if (response.indexOf(F("AIP")) != -1) {
    st = response.indexOf(F("AIP"))+5;
    ed = response.indexOf('"', st+1);
    ip = response.substring(st, ed);
    Serial.print(F("ip: ")); Serial.println(ip);
  }
}

uint8_t retry = 1;

String sendData(String order) {
  String command = F("AT+");
  command += order;
  command += F("\r\n");
  esp01.print(command); // send the read character to the esp01
  unsigned long int time = millis();
  String response = "";
  while( (time+20000) > millis()) {
    while(esp01.available()) {  // The esp has data so display its output to the serial window
      char c = esp01.read(); // read the next character.
      response+=c;
    }
    if (response.indexOf(F("OK")) != -1) { retry = 0; Serial.println(F("OK")); break; } 
    else if (response.indexOf(F("FAIL")) != -1 || response.indexOf(F("ERROR")) != -1) { 
      if (response.indexOf(F("FAIL")) != -1) retry++;
      else if (response.indexOf(F("ERROR")) != -1) { Serial.println(F("ERROR")); break; } 
      Serial.print(command); Serial.println(F("Failed")); break; 
    }
  }
  return response;
}

String addID(String order, String ssid_AP, String pass_AP) {
  String temp = order+'"'+ssid_AP+'"'+','+'"'+pass_AP+'"';
  return temp;
}

void setup() {
  Serial.begin(9600);
  esp01.begin(9600); // your esp's baud rate might be different
  sendData(F("CWQIF")); // disconnect AP if connected
  sendData(F("CWQAP")); // disconnect wifi if connected
  sendData(F("CWMODE=3")); // configure as access point (working mode: AP+STA)
  sendData(F("CWDHCP=1,1"));
  sendData(addID(F("CWSAP="),ssid_AP,pass_AP)+','+String(10)+','+String(3)); 
  retry = 1;
  while(retry) { 
    sendData(addID(F("CWJAP="),ssid,pass)); 
    if (retry > 1) { Serial.print(F("Retrying to connect: ")); Serial.println(retry-1); }
    if (retry > 4) { Serial.println(F("connection failed")); retry = 0; }
  }
  sendData(F("CIPMUX=1")); // configure for multiple connections
  sendData(F("CIPSERVER=1,80")); // turn on server on port 80
  ipCheck(sendData(F("CIFSR"))); // // get ip address
}

// http://www.kma.go.kr/wid/queryDFSRSS.jsp?zone=1159068000
const char host[] PROGMEM = "www.kma.go.kr";
const char url[]  PROGMEM = "/wid/queryDFSRSS.jsp?zone=1159068000";

bool OK200 = false;
bool sentREQ = false;
bool gotWeather = false;

void get_weather() {
  if (!sentREQ) {
    Serial.println(F("Starting connection to server..."));
    bool connectOK = false;
    String cip = F("AT+CIPSTART=3,"); // connection ID 3 (ID: 0 ~ 4)
    cip += '"'; cip += F("TCP"); cip += '"';
    cip += ','; cip += '"';
    cip += (const __FlashStringHelper *)host;
    cip += '"'; cip += ',';
    cip += F("80"); // port number
    cip += F("\r\n");
    esp01.print(cip);
    unsigned long int time = millis();
    while (time+2000 > millis()) {
      cip = esp01.readStringUntil('\n');
      if (cip.indexOf(F("OK")) != -1) { connectOK = true; Serial.println(F("OK")); break; }
      else if (cip.indexOf(F("ERROR")) != -1) { Serial.println(F("ERROR")); break; }
    }
    if (connectOK) {
      Serial.println(F("Connected to server"));
      String temp = F("GET ");
      temp += (const __FlashStringHelper *)url;
      temp += F(" HTTP/1.1\r\nHost: ");
      temp += (const __FlashStringHelper *)host;
      temp += F("\r\nConnection: close\r\n\r\n");
      cip = F("AT+CIPSEND=");
      cip += 3; // connection ID 3 (ID: 0 ~ 4)
      cip += ',';
      cip += temp.length();
      cip += F("\r\n");
      esp01.print(cip);
      time = millis();
      while (time+2000 > millis()) {
        cip = esp01.readStringUntil('\n');
        if (cip.indexOf(F("OK")) != -1) { Serial.println(F("OK")); break; }
        else if (cip.indexOf(F("ERROR")) != -1) { Serial.println(F("ERROR")); break; }
      }
      esp01.print(temp);
      sentREQ = true;
      gotWeather = true;
    }
  }
}

// RSS 날씨 정보 저장 변수
// RSS 날씨 정보 저장 변수
String line0 = "";
String line1 = "";

uint8_t count = 0; // RSS 날씨 정보 분류 카운터
uint8_t tryCount = 0;

// 온도 저장 변수
float temp0;
float temp1;

void parsing() {
  String announce_time;
  int tm_start= line0.indexOf(F("<tm>")); // "<tm>"문자가 시작되는 인덱스 값('<'의 인덱스)을 반환한다. 
  int tm_end= line0.indexOf(F("</tm>"));  
  announce_time = line0.substring(tm_start + 4, tm_end); // +4: "<tm>"스트링의 크기 4바이트, 4칸 이동
  Serial.print(F("announce_time: ")); Serial.println(announce_time);
  String hour;
  int hour_start= line0.indexOf(F("<hour>"));
  int hour_end= line0.indexOf(F("</hour>"));
  hour = line0.substring(hour_start + 6, hour_end);
  Serial.print(F("hour: ")); Serial.println(hour);
  String temp;
  int temp_start= line0.indexOf(F("<temp>"));
  int temp_end= line0.indexOf(F("</temp>"));
  temp = line0.substring(temp_start + 6, temp_end);
  Serial.print(F("temp: ")); Serial.println(temp);
  temp0 = temp.toFloat();   // 자료형 변경 String -> float
  Serial.print(F("temp0: ")); Serial.println(temp0);
  String wfEn;
  int wfEn_start= line0.indexOf(F("<wfEn>"));
  int wfEn_end= line0.indexOf(F("</wfEn>"));
  wfEn = line0.substring(wfEn_start + 6, wfEn_end);
  Serial.print(F("weather: ")); Serial.println(wfEn);
  line0 = ""; // 스트링 변수 line0 데이터 추출 완료 
  Serial.println();
  hour_start= line1.indexOf(F("<hour>"));
  hour_end= line1.indexOf(F("</hour>"));
  hour = line1.substring(hour_start + 6, hour_end);
  Serial.print(F("hour: ")); Serial.println(hour);
  temp_start= line1.indexOf(F("<temp>"));
  temp_end= line1.indexOf(F("</temp>"));
  temp = line1.substring(temp_start + 6, temp_end);
  Serial.print(F("temp: ")); Serial.println(temp);
  temp1 = temp.toFloat();   // 자료형 변경 String -> float
  Serial.print(F("temp1: ")); Serial.println(temp1);
  wfEn_start= line1.indexOf(F("<wfEn>"));
  wfEn_end= line1.indexOf(F("</wfEn>"));
  wfEn = line1.substring(wfEn_start + 6, wfEn_end);
  Serial.print(F("weather: ")); Serial.println(wfEn);
  line1 = ""; // 스트링 변수 line1 데이터 추출 완료 
}

bool header = false;

void loop() {
  if (!ip.startsWith(F("0"))) { // 공유기로부터 IP주소를 할당받은 경우
    if (!gotWeather) {
      if (tryCount < 3) { get_weather(); tryCount++; }
    }
  }
  if (sentREQ) { // 날씨 정보가 들어오는 동안
    if (!OK200) {
      if (esp01.find('+')) {
        line0 = esp01.readStringUntil('\n');
        if (line0.indexOf(F("200")) != -1) OK200 = true;
        line0 = "";
      } else { 
        line0 = esp01.readStringUntil('\n');
        if (line0.endsWith(F("D"))) {
          if (line0.endsWith(F("CLOSED"))) sentREQ = false; // HTTP connection closed
        }
      }
    } else {
      if (!header) {
        line0 = esp01.readStringUntil('\n');
        if (line0.indexOf(F("<header>")) != -1) { header = true; line0 = ""; }
      } else {
        bool finish = false;
        while (esp01.available()) {
          char c = esp01.read();
          if (c == '<') count++;
          if (count <= 50) line0 += c;
          else if (count > 50 && count <= 90) line1 += c;
          else if (count > 90) { finish = true; break; }
        }
        if (finish) {
          Serial.println(F("Finished Reading"));
          Serial.println(line0);
          Serial.println(line1);
          parsing();
          gotWeather = true; // 날씨 작업 종료
          count = 0; header = false; OK200 = false; tryCount = 0; // 초기화 sentREQ = false; 
        }
      }
    }
  } else {
    if (esp01.available()) {
      line0 = esp01.readStringUntil('\n');
      Serial.println(line0);
    }
  }
}
